package goodsmanage

import (
	"errors"
	"github.com/gin-gonic/gin"
	"go-admin/app/admin/models"
	"go-admin/logger"
	"go-admin/tools/app"
	"net/http"
)

func HomeCarouselList(c *gin.Context) {
	carousel := &models.HomeCarousel{}
	all, err := carousel.List()
	if err != nil {
		logger.Errorf("err:", err)
		app.Error(c, http.StatusInternalServerError, err, "查询失败")
		return
	}
	app.OK(c, all, "")
}

func HomeCarouselAdd(c *gin.Context) {
	m := &models.HomeCarousel{}
	if c.ShouldBindJSON(m) != nil {
		logger.Errorf("para err")
		app.Error(c, http.StatusBadRequest, errors.New("para err"), "参数错误")
		return
	}
	err := m.Add()
	if err != nil {
		logger.Errorf("err:", err)
		app.Error(c, http.StatusInternalServerError, err, "查询失败")
		return
	}
	app.OK(c, m, "")
}

func HomeCarouselDel(c *gin.Context) {
	req := struct {
		HomeCarouselId uint32 `json:"home_carousel_id"`
	}{}
	if c.ShouldBindJSON(&req) != nil {
		logger.Errorf("para err")
		app.Error(c, http.StatusBadRequest, errors.New("para err"), "参数错误")
		return
	}
	carousel := &models.HomeCarousel{}
	carousel.ID = req.HomeCarouselId
	err := carousel.Del()
	if err != nil {
		logger.Errorf("err:", err)
		app.Error(c, http.StatusInternalServerError, err, "查询失败")
		return
	}
	app.OK(c, nil, "")
}

func HomeCarouselModify(c *gin.Context) {
	carousel := &models.HomeCarouselModifyReq{}
	if c.ShouldBindJSON(carousel) != nil {
		logger.Errorf("para err")
		app.Error(c, http.StatusBadRequest, errors.New("para err"), "参数错误")
		return
	}
	err := carousel.Modify()
	if err != nil {
		logger.Errorf("err:", err)
		app.Error(c, http.StatusInternalServerError, err, "查询失败")
		return
	}
	app.OK(c, carousel, "")
}
